# Window.py -- Pamhyr
# Copyright (C) 2023-2026  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

from tools import timer, trace

from View.Tools.PamhyrWindow import PamhyrWindow
from View.Tools.PamhyrDelegate import PamhyrExTimeDelegate

from PyQt5.QtGui import (
    QKeySequence,
)

from PyQt5.QtCore import (
    Qt, QVariant, QAbstractTableModel, QCoreApplication,
)

from PyQt5.QtWidgets import (
    QDialogButtonBox, QPushButton, QLineEdit,
    QFileDialog, QTableView, QAbstractItemView,
    QUndoStack, QShortcut, QAction, QItemDelegate,
    QHeaderView,
)

from View.Tools.Plot.PamhyrCanvas import MplCanvas
from View.Tools.Plot.PamhyrToolbar import PamhyrPlotToolbar

from View.LateralContributionsAdisTS.Edit.translate import LCETranslate
from View.LateralContributionsAdisTS.Edit.Table import TableModel
from View.LateralContributionsAdisTS.Edit.Plot import Plot

_translate = QCoreApplication.translate


class EditLateralContributionAdisTSWindow(PamhyrWindow):
    _pamhyr_ui = "EditLateralContributionAdisTS"
    _pamhyr_name = "Edit lateral contribution AdisTS"

    def __init__(self, data=None, study=None, config=None, parent=None):
        self._data = data
        trad = LCETranslate()

        name = trad[self._pamhyr_name]

        if self._data is not None:
            if self._data.reach is not None:
                reach_name = next(filter(
                    lambda reach: reach.id == self._data.reach,
                    study.river.reachs()
                )).name
            else:
                reach_name = trad['not_associated']

            if self._data.begin_rk is not None:
                begin_rk = self._data.begin_rk
            else:
                begin_rk = trad['not_associated']

            if self._data.end_rk is not None:
                end_rk = self._data.end_rk
            else:
                end_rk = trad['not_associated']

            name += (
                f" - {study.name} - " +
                f"{reach_name} - " +
                f"({begin_rk} - " +
                f"{end_rk})"
            )

        super(EditLateralContributionAdisTSWindow, self).__init__(
            title=name,
            study=study,
            config=config,
            trad=trad,
            parent=parent
        )

        self._hash_data.append(data)

        self.setup_table()
        self.setup_plot()
        self.setup_connections()

    def setup_table(self):
        self._delegate_time = PamhyrExTimeDelegate(
            data=self._data,
            mode=self._study.time_system,
            parent=self
        )

        if self._study.is_editable():
            editable_headers = self._trad.get_dict("table_headers")
        else:
            editable_headers = []

        headers = {}
        table_headers = self._trad.get_dict("table_headers")
        for h in self._data.header:
            headers[h] = table_headers[h]

        table = self.find(QTableView, "tableView")
        self._table = TableModel(
            table_view=table,
            table_headers=headers,
            editable_headers=editable_headers,
            delegates={
                # "time": self._delegate_time,
            },
            data=self._data,
            undo=self._undo_stack,
            trad=self._trad,
            opt_data=self._study.time_system
        )

        table.setModel(self._table)
        table.setSelectionBehavior(QAbstractItemView.SelectRows)
        table.horizontalHeader().setSectionResizeMode(QHeaderView.Stretch)
        table.setAlternatingRowColors(True)

    def setup_plot(self):
        self.canvas = MplCanvas(width=5, height=4, dpi=100)
        self.canvas.setObjectName("canvas")
        self.toolbar = PamhyrPlotToolbar(
            self.canvas, self
        )
        self.verticalLayout.addWidget(self.toolbar)
        self.verticalLayout.addWidget(self.canvas)

        self.plot = Plot(
            canvas=self.canvas,
            data=self._data,
            mode=self._study.time_system,
            toolbar=self.toolbar,
            trad=self._trad,
            parent=self
        )
        self.plot.draw()

    def setup_connections(self):
        if self._study.is_editable():
            self.find(QAction, "action_add").triggered.connect(self.add)
            self.find(QAction, "action_del").triggered.connect(self.delete)

        self._table.dataChanged.connect(self.update)

    def update(self):
        self.plot.update()

    def index_selected_row(self):
        table = self.find(QTableView, "tableView")
        return table.selectionModel()\
                    .selectedRows()[0]\
                    .row()

    def index_selected_rows(self):
        table = self.find(QTableView, "tableView")
        return list(
            # Delete duplicate
            set(
                map(
                    lambda i: i.row(),
                    table.selectedIndexes()
                )
            )
        )

    def add(self):
        rows = self.index_selected_rows()
        if len(self._data) == 0 or len(rows) == 0:
            self._table.add(0)
        else:
            self._table.add(rows[0])

        self.plot.update()

    def delete(self):
        rows = self.index_selected_rows()
        if len(rows) == 0:
            return

        self._table.delete(rows)
        self.plot.update()

    def _undo(self):
        self._table.undo()
        self.plot.update()

    def _redo(self):
        self._table.redo()
        self.plot.update()
